<?php

namespace Drupal\orange_dam\Plugin\migrate\process;

use Drupal\migrate\MigrateExecutableInterface;
use Drupal\migrate\Row;
use Drupal\node\NodeInterface;

/**
 * Alter the published state if the passed in field is empty.
 *
 * @MigrateProcessPlugin(
 *   id = "orange_dam_unpublish_on_empty"
 * )
 *
 * @code
 * status:
 *   plugin: orange_dam_unpublish_on_empty
 *   source: foo
 *   field: bar
 * @endcode
 */
class OrangeDamUnpublishOnEmpty extends OrangeDamProcessBase {

  /**
   * {@inheritdoc}
   */
  public function transform($value, MigrateExecutableInterface $migrate_executable, Row $row, $destination_property): bool {
    // If the field is empty, mark the item as unpublished.
    if (empty($this->configuration['field'])) {
      return NodeInterface::NOT_PUBLISHED;
    }
    // Leave the value unaltered.
    return $value;
  }

}
